<?php

////////////////////////////////////////////////////////////////////////////////
// Get Featured Image
////////////////////////////////////////////////////////////////////////////////
function get_feat_image() {
  global $post, $posts;
  $first_img = '';
  ob_start();
  ob_end_clean();
  $output = preg_match_all('/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $post->post_content, $matches);
  $first_img = $matches [1] [0];

  if(empty($first_img)){ //Defines a default image
  	$img_dir = get_bloginfo('template_directory');
    $first_img = $img_dir . '/images/featdefault.jpg';
  }
  return $first_img;
}

////////////////////////////////////////////////////////////////////////////////

// Excerpt Feature

////////////////////////////////////////////////////////////////////////////////

function the_excerpt_feature($excerpt_length=30, $allowedtags='', $filter_type='none', $use_more_link=true, $more_link_text="[Read More]", $force_more_link=true, $fakeit=1, $fix_tags=true) {

	if (preg_match('%^content($|_rss)|^excerpt($|_rss)%', $filter_type)) {

		$filter_type = 'the_' . $filter_type;

	}

	$text = apply_filters($filter_type, get_the_excerpt_feature($excerpt_length, $allowedtags, $use_more_link, $more_link_text, $force_more_link, $fakeit));

	$text = ($fix_tags) ? balanceTags($text) : $text;

	echo $text;

}

function get_the_excerpt_feature($excerpt_length, $allowedtags, $use_more_link, $more_link_text, $force_more_link, $fakeit) {

	global $id, $post;

	$output = '';

	$output = $post->post_excerpt;

	if (!empty($post->post_password)) { // if there's a password

		if ($_COOKIE['wp-postpass_'.COOKIEHASH] != $post->post_password) {  // and it doesn't match the cookie

			$output = __('There is no excerpt because this is a protected post.');

			return $output;

		}

	}

	// If we haven't got an excerpt, make one.

	if ((($output == '') && ($fakeit == 1)) || ($fakeit == 2)) {

		$output = $post->post_content;

		$output = strip_tags($output, $allowedtags);

        $output = preg_replace( '|\[(.+?)\](.+?\[/\\1\])?|s', '', $output );

		$blah = explode(' ', $output);

		if (count($blah) > $excerpt_length) {

			$k = $excerpt_length;

			$use_dotdotdot = 1;

		} else {

			$k = count($blah);

			$use_dotdotdot = 0;

		}

		$excerpt = '';

		for ($i=0; $i<$k; $i++) {

			$excerpt .= $blah[$i] . ' ';

		}

		// Display "more" link (use css class 'feat-link' to set layout).

		if (($use_more_link && $use_dotdotdot) || $force_more_link) {

			$excerpt .= "...&nbsp;<a href=\"". get_permalink() . "#more-$id\" class=\"feat-link\">$more_link_text</a>";

		} else {

			$excerpt .= ($use_dotdotdot) ? '...' : '';

		}

		 $output = $excerpt;

	} // end if no excerpt

	return $output;

}




////////////////////////////////////////////////////////////////////////////////
// Get Recent Comments With Avatar
////////////////////////////////////////////////////////////////////////////////
function get_avatar_recent_comment() {

global $wpdb;

$sql = "SELECT DISTINCT ID, post_title, post_password, comment_ID,
comment_post_ID, comment_author, comment_author_email, comment_date_gmt, comment_approved,
comment_type,comment_author_url,
SUBSTRING(comment_content,1,30) AS com_excerpt
FROM $wpdb->comments
LEFT OUTER JOIN $wpdb->posts ON ($wpdb->comments.comment_post_ID =
$wpdb->posts.ID)
WHERE comment_approved = '1' AND comment_type = '' AND
post_password = ''
ORDER BY comment_date_gmt DESC LIMIT 5";

$comments = $wpdb->get_results($sql);
$output = $pre_HTML;
$gravatar_status = 'on'; /* off if not using */

foreach ($comments as $comment) {

$email = $comment->comment_author_email;
$grav_name = $comment->comment_author_name;
$grav_url = "http://www.gravatar.com/avatar.php?gravatar_id=".md5($email). "&amp;size=35";

?>
<li>
<?php if($gravatar_status == 'on') { ?>
<img class="alignleft" src="<?php echo $grav_url; ?>" alt="<?php echo $grav_namel ?>" />
<?php } ?>
<?php echo strip_tags($comment->comment_author); ?>: <br />
<a href="<?php echo get_permalink($comment->ID); ?>#comment-<?php echo $comment->comment_ID; ?>" title="on <?php echo $comment->post_title; ?>">
<?php echo strip_tags($comment->com_excerpt); ?>...
</a>
</li>
<?php
}
}

////////////////////////////////////////////////////////////////////////////////
// WP-PageNavi
////////////////////////////////////////////////////////////////////////////////


function custom_wp_pagenavi($before = '', $after = '', $prelabel = '', $nxtlabel = '', $pages_to_show = 5, $always_show = false) {
	global $request, $posts_per_page, $wpdb, $paged;
	if(empty($prelabel)) {
		$prelabel  = '<strong>&laquo;</strong>';
	}
	if(empty($nxtlabel)) {
		$nxtlabel = '<strong>&raquo;</strong>';
	}
	$half_pages_to_show = round($pages_to_show/2);
	if (!is_single()) {
		if(!is_category()) {
			preg_match('#FROM\s(.*)\sORDER BY#siU', $request, $matches);
		} else {
			preg_match('#FROM\s(.*)\sGROUP BY#siU', $request, $matches);
		}
		$fromwhere = $matches[1];
		$numposts = $wpdb->get_var("SELECT COUNT(DISTINCT ID) FROM $fromwhere");
		$max_page = ceil($numposts /$posts_per_page);
		if(empty($paged)) {
			$paged = 1;
		}
		if($max_page > 1 || $always_show) {
			echo "$before <div class=\"wp-pagenavi\"><span class=\"pages\">Page $paged of $max_page:</span>";
			if ($paged >= ($pages_to_show-1)) {
				echo '<a href="'.get_pagenum_link().'">&laquo; First</a>&nbsp;';
			}
			previous_posts_link($prelabel);
			for($i = $paged - $half_pages_to_show; $i  <= $paged + $half_pages_to_show; $i++) {
				if ($i >= 1 && $i <= $max_page) {
					if($i == $paged) {
						echo "<strong class='current'>$i</strong>";
					} else {
						echo ' <a href="'.get_pagenum_link($i).'">'.$i.'</a> ';
					}
				}
			}
			next_posts_link($nxtlabel, $max_page);
			if (($paged+$half_pages_to_show) < ($max_page)) {
				echo '&nbsp;<a href="'.get_pagenum_link($max_page).'">Last &raquo;</a>';
			}
			echo "</div> $after";
		}
	}
}

////////////////////////////////////////////////////////////////////////////////
// Comment And Ping Setup
////////////////////////////////////////////////////////////////////////////////

function list_pings($comment, $args, $depth) {
$GLOBALS['comment'] = $comment; ?>
<li id="comment-<?php comment_ID(); ?>"><?php comment_author_link(); ?>
<?php }

add_filter('get_comments_number', 'comment_count', 0);

function comment_count( $count ) {
	global $id;
	$comments_by_type = &separate_comments(get_comments('post_id=' . $id));
	return count($comments_by_type['comment']);
}


////////////////////////////////////////////////////////////////////////////////
// Comment and pingback separate controls
////////////////////////////////////////////////////////////////////////////////

$bm_trackbacks = array();
$bm_comments = array();

function split_comments( $source ) {

if ( $source ) foreach ( $source as $comment ) {

global $bm_trackbacks;
global $bm_comments;

if ( $comment->comment_type == 'trackback' || $comment->comment_type == 'pingback' ) {
$bm_trackbacks[] = $comment;
} else {
$bm_comments[] = $comment;
}
}
}

////////////////////////////////////////////////////////////////////////////////

// Theme Option

////////////////////////////////////////////////////////////////////////////////


$themename = "Bluemish";
$shortname = "rk";

$wp_dropdown_rd_admin = $wpdb->get_results("SELECT $wpdb->term_taxonomy.term_id,name,description,count FROM $wpdb->term_taxonomy LEFT JOIN $wpdb->terms ON $wpdb->term_taxonomy.term_id = $wpdb->terms.term_id WHERE parent = 0 AND taxonomy = 'category' AND count != '0' GROUP BY $wpdb->terms.name ORDER by $wpdb->terms.name ASC");
$wp_getcat = array();
foreach ($wp_dropdown_rd_admin as $category_list) {
$wp_getcat[$category_list->term_id] = $category_list->name;
}
$category_bulk_list = array_unshift($wp_getcat, "Выберите рубрику:");
$number_entries = array("Количество записей:","1","2","3","4","5","6","7","8","9","10");


$options = array (

    array(	"name" => "Smooth Gallery Settings",
            "type" => "heading",
            ),

			array(	"name" => "Enable <strong>Featured Gallery</strong> On Homepage?<br /><em>*Disable by default, Choose Yes to enable it.</em>",
			"id" => $shortname."_bluemish_featured_enabling",
            "type" => "select",
            "std" => "No",
			"options" => array("No", "Yes")),
			
			array(	"name" => "Choose Which <strong>Category</strong> To Feature?",
			"id" => $shortname."_bluemish_featured_category",
            "type" => "select",
            "std" => "Select A Category",
			"options" => $wp_getcat),

			array(	"name" => "Choose How Many <strong>Post</strong> To Display On The Chosen Category?",
			"id" => $shortname."_bluemish_featured_number",
            "type" => "select",
            "std" => "Select A Number",
			"options" => $number_entries),


			array(	"name" => "</div></div>",
            "type" => "close",
            ),

    array(	"name" => "Google Adsense & Analytics Settings",
            "type" => "heading",
            ),


    array(	"name" => "Enable Google Adsense loop in post <br /><em>*default are disable, you can activate it by choosing enable</em>",
			"id" => $shortname."_bluemish_google_activate",
            "type" => "select",
            "std" => "disable",
			"options" => array("disable", "enable")),


    array(	"name" => "Insert Google Adsense 336 x 280 code <br /><em>*copy and paste your google code here</em>",
			"id" => $shortname."_bluemish_google_code",
            "type" => "textarea",
            "std" => "",
            ),
			
	
	array(	"name" => "Insert Google Analytics code <br /><em>*optional - leave it blank if not using</em>",
			"id" => $shortname."_bluemish_google_analytics",
            "type" => "textarea",
            "std" => "",
            ),

     array(	"name" => "</div></div>",
            "type" => "close",
            ),
			

    array(  "name" => "Social Media Tools Settings",
            "type" => "heading",
         	),
			
			array(	"name" => "Insert your Feedburner ID here <br /><em>*leave blank if not necessary</em>
			<br /><em>*Register Feedburner for free <a href=\"http://feedburner.google.com\" target=\"_blank\">here</a> if you don't have one</em>",
			"id" => $shortname."_bluemish_rssfeed",
            "type" => "text",
            "box" => "social",
            "std" => "",
            ),
			
			array(	"name" => "Insert your Twitter ID here
			<br /><em>*leave blank if not necessary</em>
			<br /><em>*Register Twitter for free <a href=\"http://www.twitter.com\" target=\"_blank\">here</a> if you don't have one</em>",
			"id" => $shortname."_bluemish_twitter",
            "type" => "text",
            "box" => "social",
            "std" => "",
            ),
			
			array(	"name" => "Insert your ShareThis button code here
			<br /><em>*leave blank if not necessary</em>
			<br /><em>*Register and get your ShareThis button for free <a href=\"http://sharethis.com/users/register/\" target=\"_blank\">here</a> if you don't have one</em>",
			"id" => $shortname."_bluemish_sharethis",
            "type" => "textarea",
            "std" => "",
            ),
			
			array(	"name" => "</div></div>",
            "type" => "close",
            ),
			
    		array(  "name" => "Sidebar Featured Video",
            "type" => "heading",
         	),
		 
		 	array(	"name" => "Insert Video Embed Code <br /><em>*You can find the embed code for videos on video sharing sites.</em>
			<br /><em>*i.e. Youtube - http://www.youtube.com/v/NG2zyeVRcbs</em>",
        	"id" => $shortname."_bluemish_emvideo",
        	"std" => "",
        	"type" => "textarea"),
			
			array(	"name" => "</div></div>",
            "type" => "close",
            ),
			
			
			array(	"name" => "Advertisement Settings",
            "type" => "heading",
            ),

    		array(	"name" => "Insert Header Banner URL Link<br /><em>*leave blank if not use</em>",
			"id" => $shortname."_bluemish_header_banner",
            "type" => "text",
            "std" => "",
            ),
			
    		array(	"name" => "Insert Header Banner IMG URL<br /><em>*leave blank if not use</em>",
			"id" => $shortname."_bluemish_header_banner_img",
            "type" => "text",
            "std" => "",
            ),


    		array(	"name" => "Insert Sidebar Banner URL Link<br /><em>*leave blank if not use</em>",
			"id" => $shortname."_bluemish_sidebar_banner",
            "type" => "text",
            "std" => "",
            ),

    		array(	"name" => "Insert Sidebar Banner IMG URL<br /><em>*leave blank if not use</em>",
			"id" => $shortname."_bluemish_sidebar_banner_img",
            "type" => "text",
            "std" => "",
            ),
			
			array(	"name" => "</div></div>",
            "type" => "close",
            ),

);




function blackmist_admin_panel() {

echo "<div id=\"admin-options\"> ";

global $themename, $shortname, $options;
if ( $_REQUEST['saved'] ) echo '<div id="update-option" class="updated fade"><strong>Настройки темы '.$themename.' сохранены.</strong></div>';
if ( $_REQUEST['reset'] ) echo '<div id="update-option" class="updated fade"><strong>Настройки темы '.$themename.' сброшены.</strong></div>';
?>


<h4>Настройки темы <?php echo "$themename"; ?></h4>

<div class="annouce">
<h1>Спасибо, что используете тему <?php echo "$themename"; ?></h1>
<p>Не забудьте <a href="http://feedburner.google.com/fb/a/mailverify?uri=MagPress&loc=en_US" title="MagPress Newsletter" target="_blank" rel="nofollow"><b>подписаться на наши письма</b></a>, чтобы получать обновления темы.</p>
</div>



<form action="" method="post">



<?php foreach ($options as $value) { ?>

<?php
switch ( $value['type'] ) {
case 'heading':
?>
<div class="get-option">
<h2><?php echo $value['name']; ?></h2>
<div class="option-save">


<?php
break;
case 'text':
?>

<div class="description"><?php echo $value['name']; ?></div>
<p><input name="<?php echo $value['id']; ?>" class="myfield" id="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" value="<?php if ( get_settings( $value['id'] ) != "") { echo get_settings( $value['id'] ); } else { echo $value['std']; } ?>" /></p>


<?php
break;
case 'select':
?>

<div class="description"><?php echo $value['name']; ?></div>
<p><select name="<?php echo $value['id']; ?>" class="myselect" id="<?php echo $value['id']; ?>">
<?php foreach ($value['options'] as $option) { ?>
<option<?php if ( get_settings( $value['id'] ) == $option) { echo ' selected="selected"'; } elseif ($option == $value['std']) { echo ' selected="selected"'; } ?>><?php echo $option; ?></option>
<?php } ?>
</select>
</p>

<?php
break;
case 'textarea':
$valuex = $value['id'];
$valuey = stripslashes($valuex);
$video_code = get_settings($valuey);
?>

<div class="description"><?php echo $value['name']; ?></div>
<p><textarea name="<?php echo $valuey; ?>" class="mytext" cols="40%" rows="8" /><?php if ( get_settings($valuey) != "") { echo stripslashes($video_code); } else { echo $value['std']; } ?></textarea></p>

<?php
break;
case 'close':
?>

</div><div class="clearfix"></div></div>

<?php
break;
default;
?>

<?php
break; } ?>





<?php } ?>






<p class="save-p">
<input name="save" type="submit" class="sbutton" value="Сохранить" />
<input type="hidden" name="action" value="save" />
</p>
</form>

<form method="post">
<p class="save-p">
<input name="reset" type="submit" class="sbutton" value="Сбросить" />
<input type="hidden" name="action" value="reset" />
</p>
</form>

</div>

<?php
}


function blackmist_admin_register() {
global $themename, $shortname, $options;
if ( $_GET['page'] == basename(__FILE__) ) {
if ( 'save' == $_REQUEST['action'] ) {
foreach ($options as $value) {
update_option( $value['id'], $_REQUEST[ $value['id'] ] ); }
foreach ($options as $value) {
if( isset( $_REQUEST[ $value['id'] ] ) ) { update_option( $value['id'], $_REQUEST[ $value['id'] ]  ); } else { delete_option( $value['id'] ); } }
header("Location: themes.php?page=functions.php&saved=true");
die;
} else if( 'reset' == $_REQUEST['action'] ) {
foreach ($options as $value) {
delete_option( $value['id'] ); }
header("Location: themes.php?page=functions.php&reset=true");
die;
}
}
add_theme_page($themename." настройки", "Настройки темы", 'edit_themes', basename(__FILE__), 'mytheme_admin_panel');
}

function blackmist_admin_head() { ?>
<link href="<?php bloginfo('template_directory'); ?>/css/admin-panel.css" rel="stylesheet" type="text/css" />
<?php }

add_action('admin_head', 'blackmist_admin_head');
add_action('admin_menu', 'blackmist_admin_register');

?>